"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskModal = void 0;
const react_1 = __importDefault(require("react"));
const polaris_icons_1 = require("@shopify/polaris-icons");
const taskify_shared_1 = require("@dotdev/taskify-shared");
const polaris_1 = require("@shopify/polaris");
const hooks_1 = require("../hooks");
const StatusBadge_1 = require("./StatusBadge");
const TaskAttemptBrowser_1 = require("./TaskAttemptBrowser");
const TaskModal = ({ open, taskRef, onClose }) => {
    const retryTask = hooks_1.useRetryTask(taskRef);
    const { task, loading } = hooks_1.useTask(taskRef);
    const primaryAction = react_1.default.useMemo(() => {
        if (!task)
            return undefined;
        return {
            icon: polaris_icons_1.ReplayMinor,
            content: "Retry",
            onAction: () => retryTask(),
            disabled: ![
                taskify_shared_1.TaskStatus.FAILED,
                taskify_shared_1.TaskStatus.TIMEOUT,
                taskify_shared_1.TaskStatus.COMPLETE,
            ].includes(task.status),
        };
    }, [task]);
    return (react_1.default.createElement(polaris_1.Modal, { large: true, open: open, loading: loading, title: "Task details", onClose: () => onClose(), primaryAction: primaryAction }, task && (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(polaris_1.Modal.Section, null,
            react_1.default.createElement(polaris_1.Stack, { spacing: "extraLoose" },
                react_1.default.createElement(polaris_1.TextContainer, null,
                    react_1.default.createElement(polaris_1.Heading, null, "Task ID"),
                    react_1.default.createElement("p", null, task.id.toUpperCase())),
                react_1.default.createElement(polaris_1.TextContainer, null,
                    react_1.default.createElement(polaris_1.Heading, null, "Type"),
                    react_1.default.createElement("p", null,
                        task.taskGroup,
                        " \u2794 ",
                        task.taskType)),
                react_1.default.createElement(polaris_1.TextContainer, null,
                    react_1.default.createElement(polaris_1.Heading, null, "Status"),
                    react_1.default.createElement(StatusBadge_1.StatusBadge, { status: task.status })))),
        react_1.default.createElement(polaris_1.Modal.Section, { subdued: true },
            react_1.default.createElement(TaskAttemptBrowser_1.TaskAttemptBrowser, { taskRef: taskRef }))))));
};
exports.TaskModal = TaskModal;
