import type Firebase from "firebase";
import { Task, TaskLog, TaskStatus, TaskAttempt, TaskDefinition, TaskInvocation } from "@dotdev/taskify-shared";
export declare const useTasks: <T extends TaskDefinition<string, string>>(options?: {
    taskGroup?: T["taskGroup"] | undefined;
    taskType?: T["taskType"] | undefined;
    limit?: number | undefined;
    status?: TaskStatus | undefined;
    taskTypes?: string[] | undefined;
}) => {
    tasks: import("react-firebase-hooks/firestore/dist/firestore/types").Data<Task<T>, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
    nextPage: () => void;
    hasNextPage: boolean;
    prevPage: () => void;
    hasPrevPage: boolean;
};
export declare const useTask: <T extends TaskDefinition<string, string> = TaskDefinition<string, string>>(taskRef?: Firebase.firestore.DocumentReference<Task<T>> | undefined) => {
    task: import("react-firebase-hooks/firestore/dist/firestore/types").Data<Task<T>, "id", "ref"> | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useTaskAttempts: (taskRef?: Firebase.firestore.DocumentReference<Task<import("@dotdev/taskify-shared").TaskRequest>> | undefined) => {
    taskAttempts: import("react-firebase-hooks/firestore/dist/firestore/types").Data<TaskAttempt, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useTaskLogs: (taskAttemptRef?: Firebase.firestore.DocumentReference<TaskAttempt> | undefined) => {
    taskLogs: import("react-firebase-hooks/firestore/dist/firestore/types").Data<TaskLog, "id", "ref">[] | undefined;
    loading: boolean;
    error: Firebase.FirebaseError | undefined;
};
export declare const useRunTask: <T extends TaskDefinition<string, string>>() => (taskRequest: T, options?: {
    openModal?: boolean;
}) => Promise<{
    taskRef: Firebase.firestore.DocumentReference<Task<T>>;
    taskAttemptRef: Firebase.firestore.DocumentReference<TaskAttempt>;
    taskInvocationRef: Firebase.firestore.DocumentReference<TaskInvocation>;
}>;
export declare const useRetryTask: (taskRef?: Firebase.firestore.DocumentReference<Task<import("@dotdev/taskify-shared").TaskRequest>> | undefined) => () => Promise<{
    taskAttemptRef: Firebase.firestore.DocumentReference<TaskAttempt>;
    taskInvocationRef: Firebase.firestore.DocumentReference<TaskInvocation>;
} | undefined>;
export declare const useViewTask: () => (taskRef: Firebase.firestore.DocumentReference<Task<import("@dotdev/taskify-shared").TaskRequest>>) => void;
export declare const useViewTaskPath: () => (taskPath: string) => void;
